=== debian/changelog ===
mopac (23.1.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/cmake_python3.patch: Refreshed.
  * debian/patches/private_libmopac.patch: Likewise.
  * debian/patches/disable_failing_tests.patch: Likewise.

 -- Michael Banck <mbanck@debian.org>  Mon, 10 Mar 2025 01:40:09 +0100
