=== debian/control ===
Source: mopac
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>= 10),
               cmake,
               gfortran,
               libblas-dev,
               liblapack-dev,
               python3,
               python3-numpy
Standards-Version: 4.1.3
Homepage: http://openmopac.net
Vcs-Browser: https://salsa.debian.org/debichem-team/mopac
Vcs-Git: https://salsa.debian.org/debichem-team/mopac.git

Package: mopac
Section: science
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Molecular Orbital PACkage (MOPAC)
 MOPAC is a general-purpose semiempirical molecular orbital package for the
 study of solid state and molecular structures and reactions.
 .
 The semiempirical Hamiltonians MNDO, AM1, PM3, PM6, RM1, MNDO-d and PM7 are
 used in the electronic part of the calculation to obtain molecular orbitals,
 the heat of formation and its derivative with respect to molecular geometry.
 .
 Using these results MOPAC calculates the vibrational spectra, thermodynamic
 quantities, isotopic substitution effects and force constants for molecules,
 radicals, ions, and polymers. For studying chemical reactions, a transition
 state location routine and two transition state optimizing routines are
 available. For users to get the most out of the program, they must understand
 how the program works, how to enter data, how to interpret the results, and
 what to do when things go wrong.
