=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	# remove static library for now
	rm -rf debian/mopac/usr/lib/

override_dh_auto_clean:
	dh_auto_clean
	rm -rf tests/__pycache__
