=== debian/watch ===
version=3
opts="repacksuffix=+dfsg,dversionmangle=auto,repack" \
https://github.com/openmopac/mopac/tags .*/v([\d.]+)\.tar\.(?:bz2|gz)
